Loading...
Searching...
No Matches
Accept Header
MIME Headers

The Accept request-header field can be used to specify certain media types which are acceptable for the response. More...

## Data Structures

struct | msg_accept_s
| Structure for Accept header. More...

## Macros

#define | MSG_ACCEPT_INIT()
| Initializer for an msg_accept_t structure.

## Typedefs

typedef struct msg_accept_s | msg_accept_t
| The structure msg_accept_t contains representation of an Accept header.

## Enumerations

enum | { msg_accept_hash }

## Functions

msg_accept_t * | msg_accept_init (msg_accept_t x[1])
| Initialize an msg_accept_t structure.
int | msg_is_accept (msg_header_t const *header)
| Test if header object is an instance of msg_accept_t.
msg_accept_t * | msg_accept_dup (su_home_t *home, msg_accept_t const *header)
| Duplicate (deep copy) msg_accept_t.
msg_accept_t * | msg_accept_copy (su_home_t *home, msg_accept_t const *header)
| Copy an msg_accept_t header structure.
msg_accept_t * | msg_accept_make (su_home_t *home, char const *s)
| Make a header structure msg_accept_t.
msg_accept_t * | msg_accept_format (su_home_t *home, char const *fmt,...)))
| Make a Accept header from formatting result.

## Variables

msg_parse_f | msg_accept_d
| Parse a Accept header.
msg_print_f | msg_accept_e
| Print a Accept header.
msg_hclass_t | msg_accept_class []
| Header class for Accept header.

## Detailed Description

The Accept request-header field can be used to specify certain media types which are acceptable for the response.

Its syntax is defined in [H14.1, S20.1] as follows:

Accept = "Accept" ":" #( media-range [ accept-params ] )
media-range = ( "*" "/" "*"
| ( type "/" "*" )
| ( type "/" subtype ) ) *( ";" parameter )
accept-params = ";" "q" "=" qvalue *( accept-extension )
accept-extension = ";" token [ "=" ( token | quoted-string ) ]

## Macro Definition Documentation

## MSG_ACCEPT_INIT

#define MSG_ACCEPT_INIT | ( |  | ) |

Initializer for an msg_accept_t structure.

A static msg_accept_t structure must be initialized with the MSG_ACCEPT_INIT() macro. For instance,

msg_accept_t msg_accept = MSG_ACCEPT_INIT;
msg_accept_t
struct msg_accept_s msg_accept_t
The structure msg_accept_t contains representation of an Accept header.
Definition msg_mime.h:54
MSG_ACCEPT_INIT
#define MSG_ACCEPT_INIT()
Initializer for an msg_accept_t structure.
Definition msg_mime_protos.h:1852

## Typedef Documentation

## msg_accept_t

typedef struct msg_accept_s msg_accept_t

The structure msg_accept_t contains representation of an Accept header.

The msg_accept_t is defined as follows:

typedef struct msg_accept_s {
msg_common_t ac_common[1]; // Common fragment info
msg_accept_t *ac_next; // Pointer to next Accept header
char const *ac_type; // Pointer to type/subtype
char const *ac_subtype; // Points after first slash in type
msg_param_t const *ac_params; // List of parameters
msg_param_t ac_q; // Value of q parameter
} msg_accept_t;
msg_common_t
struct msg_common_s msg_common_t
Common part of header.
Definition msg_types.h:89
msg_accept_s
Structure for Accept header.
Definition msg_mime.h:80
msg_accept_s::ac_type
char const * ac_type
Pointer to type/subtype.
Definition msg_mime.h:83
msg_accept_s::ac_q
char const * ac_q
Value of q parameter.
Definition msg_mime.h:86
msg_accept_s::ac_params
msg_param_t const * ac_params
List of parameters.
Definition msg_mime.h:85
msg_accept_s::ac_subtype
char const * ac_subtype
Points after first slash in type.
Definition msg_mime.h:84
msg_accept_s::ac_next
msg_accept_t * ac_next
Pointer to next Accept header.
Definition msg_mime.h:82
msg_accept_s::ac_common
msg_common_t ac_common[1]
Common fragment info.
Definition msg_mime.h:81

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
msg_accept_hash | Hash of Accept header.

## Function Documentation

## msg_accept_copy()

msg_accept_t * msg_accept_copy | ( | su_home_t * | home,
|  | msg_accept_t const * | header )

inline

Copy an msg_accept_t header structure.

The function msg_accept_copy() copies a header structure header. If the header structure header contains a reference (`header->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header structure header.

Parameters

  home | memory home used to allocate new structure
  header | pointer to the header structure to be duplicated

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old header, including the encoding of the old header, if present.

Example
  accept = msg_accept_copy(home, msg->msg_accept);
  msg_accept_copy
  msg_accept_t * msg_accept_copy(su_home_t *home, msg_accept_t const *header)
  Copy an msg_accept_t header structure.
  Definition msg_mime_protos.h:1981

Returns
  The function msg_accept_copy() returns a pointer to newly copied header structure, or NULL upon an error.

## msg_accept_dup()

msg_accept_t * msg_accept_dup | ( | su_home_t * | home,
|  | msg_accept_t const * | header )

inline

Duplicate (deep copy) msg_accept_t.

The function msg_accept_dup() duplicates a header structure header. If the header structure header contains a reference (`header->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  header | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  accept = msg_accept_dup(home, msg->msg_accept);
  msg_accept_dup
  msg_accept_t * msg_accept_dup(su_home_t *home, msg_accept_t const *header)
  Duplicate (deep copy) msg_accept_t.
  Definition msg_mime_protos.h:1936

Returns
  The function msg_accept_dup() returns a pointer to the newly duplicated msg_accept_t header structure, or NULL upon an error.

## msg_accept_format()

msg_accept_t * msg_accept_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Accept header from formatting result.

The function msg_accept_format() makes a new Accept header object using snprintf-formatted result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and uses the formatting result as the header value.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Note
  This function may be implemented as a macro calling msg_header_format().

Returns
  The function msg_accept_format() returns a pointer to newly makes header structure, or NULL upon an error.

## msg_accept_init()

msg_accept_t * msg_accept_init | ( | msg_accept_t | x[1] | ) |

inline

Initialize an msg_accept_t structure.

An msg_accept_t structure can be initialized with the msg_accept_init() function/macro. For instance,

msg_accept_t msg_accept;
msg_accept_init(&msg_accept);
msg_accept_init
msg_accept_t * msg_accept_init(msg_accept_t x[1])
Initialize an msg_accept_t structure.
Definition msg_mime_protos.h:1869

Parameters

  x | pointer to msg_accept_t structure

## msg_accept_make()

msg_accept_t * msg_accept_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a header structure msg_accept_t.

The function msg_accept_make() makes a new msg_accept_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Note
  This function may be implemented as a macro calling msg_header_make().

Returns
  The function msg_accept_make() returns a pointer to newly maked msg_accept_t header structure, or NULL upon an error.

## msg_is_accept()

int msg_is_accept | ( | msg_header_t const * | header | ) |

inline

Test if header object is an instance of msg_accept_t.

The function msg_is_accept() returns true (nonzero) if the header class is an instance of Accept header object and false (zero) otherwise.

Parameters

  header | pointer to the header structure to be tested

Returns
  The function msg_is_accept() returns true (nonzero) if the header object is an instance of header Accept header and false (zero) otherwise.

## Variable Documentation

## msg_accept_class

msg_hclass_t msg_accept_class[]

extern

Header class for Accept header.

The header class msg_accept_class defines how a Accept header header is parsed and printed. It also contains methods used by message parser and other functions to manipulate the msg_accept_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.